From d2a300e741de607b5be91bfd547e8a7f10d84966 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Aug 25 2017 08:50:55 +0000
Subject: [PATCH 929/1001] Add a subclassable function to signal a value should not be cached


---

diff --git a/hubs/widgets/caching.py b/hubs/widgets/caching.py
index 2476ca8..6a499a5 100644
--- a/hubs/widgets/caching.py
+++ b/hubs/widgets/caching.py
@@ -68,10 +68,24 @@ class CachedFunction(object):
         key = self.get_cache_key()
         log.debug("Accessing cache key %s", key)
         return cache.get_or_create(
-            key, self.execute)
+            key, self.execute, should_cache_fn=self._should_cache)
 
     __call__ = get_data
 
+    def _should_cache(self, value):
+        """Indicates if the result should be cached.
+
+        This function which will receive the value returned by
+        :py:meth:`.execute`, and will then return ``True`` or ``False``,
+        indicating if the value should actually be cached or not. If it returns
+        ``False``, the value is still returned, but isn't cached. E.g.::
+
+                return (value is not None)
+
+        Defaults to ``True``.
+        """
+        return True
+
     def should_invalidate(self, message):
         """
         Tell the cache invalidator if the received message should invalidate

